/*----------------------------------------------------------------------------*
 * No Warranty                                                                *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MTK with respect to any MTK *
 * Deliverables or any use thereof, and MTK Deliverables are provided on an   *
 * "AS IS" basis.  MTK hereby expressly disclaims all such warranties,        *
 * including any implied warranties of merchantability, non-infringement and  *
 * fitness for a particular purpose and any warranties arising out of course  *
 * of performance, course of dealing or usage of trade.  Parties further      *
 * acknowledge that Company may, either presently and/or in the future,       *
 * instruct MTK to assist it in the development and the implementation, in    *
 * accordance with Company's designs, of certain softwares relating to        *
 * Company's product(s) (the "Services").  Except as may be otherwise agreed  *
 * to in writing, no warranties of any kind, whether express or implied, are  *
 * given by MTK with respect to the Services provided, and the Services are   *
 * provided on an "AS IS" basis.  Company further acknowledges that the       *
 * Services may contain errors, that testing is important and Company is      *
 * solely responsible for fully testing the Services and/or derivatives       *
 * thereof before they are used, sublicensed or distributed.  Should there be *
 * any third party action brought against MTK, arising out of or relating to  *
 * the Services, Company agree to fully indemnify and hold MTK harmless.      *
 * If the parties mutually agree to enter into or continue a business         *
 * relationship or other arrangement, the terms and conditions set forth      *
 * hereunder shall remain effective and, unless explicitly stated otherwise,  *
 * shall prevail in the event of a conflict in the terms in any agreements    *
 * entered into between the parties.                                          *
 *---------------------------------------------------------------------------*/


#include "msdc_mmc_protocal.h"
#include "msdc_basic.h"
#include "x_printf.h"
#include "x_timer.h"
#include "x_os.h"

#if defined(CC_MSDC_ENABLE) || defined(CC_SDMMC_SUPPORT)

volatile   UINT32 _u4MsdcAccuVect = 0x00;

/*
 * basic function
 */
INT32 MsdcAutoKTuneSampleEdge(INT32 fgCmd, INT32 fgRead, INT32 fgWrite,msdc_cmd *pCmd)
{
	UINT32 u4OldVal = 0;
	UINT32 u4NewVal = 0;

	if (fgCmd)//0X04[1]
	{
		MSDC_GET_FIELD(MSDC_IOCON, MSDC_IOCON_R_SMPL, u4OldVal);
		u4NewVal = u4OldVal ^ 0x1;
		MSDC_SET_FIELD(MSDC_IOCON, MSDC_IOCON_R_SMPL, u4NewVal);
		MSDC_LOG(MSG_LVL_ERR, "Tune AutoK CMD sampel edge %d --> %d \n", u4OldVal, u4NewVal);
	}
	else if (fgRead)
	{
		if (HOST_EMMC == pCmd->host_type) //emmc
		{
			MSDC_GET_FIELD(MSDC_IOCON, MSDC_IOCON_D_SMPL, u4OldVal);
			u4NewVal = u4OldVal ^ 0x1;
			MSDC_SET_FIELD(MSDC_IOCON, MSDC_IOCON_D_SMPL, u4NewVal);
			MSDC_LOG(MSG_LVL_ERR, "EMMC Tune AutoK READ sampel edge %d --> %d \n", u4OldVal, u4NewVal);
		}
		else if (HOST_SD == pCmd->host_type) //SD
		{
			MSDC_SET_FIELD(MSDC_IOCON, MSDC_IOCON_D_SMPL, 0);

			MSDC_GET_FIELD(PATCH_BIT0, RD_DAT_SEL, u4OldVal);
			u4NewVal = u4OldVal ^ 0x1;
			MSDC_SET_FIELD(PATCH_BIT0, RD_DAT_SEL, u4NewVal);
			MSDC_LOG(MSG_LVL_ERR, "SD Tune AutoK READ sampel edge %d --> %d \n", u4OldVal, u4NewVal);
		}
	}
	else if (fgWrite)
	{
		MSDC_GET_FIELD(PATCH_BIT2, (0x1  << 25)/*MSDC_BIT2_CFG_CRCSTS_EDGE*/, u4OldVal);
		u4NewVal = u4OldVal ^ 0x1;
		MSDC_SET_FIELD(PATCH_BIT2, (0x1  << 25)/*MSDC_BIT2_CFG_CRCSTS_EDGE*/, u4NewVal);
		MSDC_LOG(MSG_LVL_ERR, "Tune AutoK WRITE sampel edge %d --> %d \n", u4OldVal, u4NewVal);

	}
	return MSDC_SUCCESS;
}

INT32 MsdcOnlineAutoKTune(INT32 fgCmd, INT32 fgRead, INT32 fgWrite, msdc_cmd *pCmd)
{
    MSDC_LOG(MSG_LVL_ERR, "Enter Autok online tune.....speedMode %d \n", pCmd->speed_mode);

	if (SPEED_MODE_HS >= pCmd->speed_mode) {
	   MsdcAutoKTuneSampleEdge(fgCmd, fgRead, fgWrite,pCmd);
	} else if (SPEED_MODE_HS200 == pCmd->speed_mode) {
		#ifdef CC_UBOOT
		MSDC_LOG(MSG_LVL_ERR, "Warning! Uboot not support HS200 autok tuning currently \n");
		#else
		if (8 != pCmd->BusWidth)
    		MSDC_LOG(MSG_LVL_ERR, "Warning! HS200 Mode,The bus width is not 8, cur val %d \n", pCmd->BusWidth);
		if (g_msdc_pub_info.p_hs200_tuning)
			g_msdc_pub_info.p_hs200_tuning(pCmd,NULL);
		#endif
	} else if (SPEED_MODE_HS400 == pCmd->speed_mode) {
		#ifdef CC_UBOOT
		MSDC_LOG(MSG_LVL_ERR, "Warning! Uboot not support HS400 autok tuning currently \n");
		#else
		if (8 != pCmd->BusWidth) {
    		MSDC_LOG(MSG_LVL_ERR, "ERROR! HS400 mode, The bus width is not 8, cur val %d \n", pCmd->BusWidth);
			return MSDC_FAILED;
    	}
		if (g_msdc_pub_info.p_hs400_tuning)
			g_msdc_pub_info.p_hs400_tuning(pCmd,NULL);
		#endif
	} else {
		MSDC_LOG(MSG_LVL_ERR, "ERROR! The current speed mode invalid \n");
		return MSDC_FAILED;
	}

	if (fgCmd) {
		if (MsdcReqCmdStart(pCmd) == MSDC_SUCCESS) {
            MSDC_LOG(MSG_LVL_WARN, "Command Tune Success\n");
            return MSDC_SUCCESS;
        } else {
			MSDC_LOG(MSG_LVL_WARN, "Command Tune Fail\n");
            return MSDC_FAILED;
		}
	} else if (fgRead) {
		if (MsdcRequest(pCmd) == MSDC_SUCCESS) {
            MSDC_LOG(MSG_LVL_WARN, "Data READ Tune Success\n");
            return MSDC_SUCCESS;
        } else {
			MSDC_LOG(MSG_LVL_WARN, "Data READ Tune Fail\n");
            return MSDC_FAILED;
		}
	} else if (fgWrite) {
		if (MsdcRequest(pCmd) == MSDC_SUCCESS) {
            MSDC_LOG(MSG_LVL_WARN, "Data Write Tune Success\n");
            return MSDC_SUCCESS;
        } else {
			MSDC_LOG(MSG_LVL_WARN, "Data Write Tune Fail\n");
            return MSDC_FAILED;
		}
	}

	return MSDC_SUCCESS;
}

/*
*private structure
*/

// Return when any interrupt is matched or timeout
INT32 MsdcWaitIntr (UINT32 vector, UINT32 timeoutCnt, UINT32 fgMode)
{
    UINT32 i, retVector;

    // Clear Vector variable
    _u4MsdcAccuVect = 0;
    retVector = INT_SD_DATTO | INT_SD_DATA_CRCERR;

    for (i = 0; i < timeoutCnt; i++)
    {
        // Status match any bit
        if ((fgMode == 0) && ((MSDC_READ32(MSDC_INT) & vector) != 0)) {
            _u4MsdcAccuVect |= MSDC_READ32(MSDC_INT);
            MSDC_WRITE32(MSDC_INT, _u4MsdcAccuVect & vector);
            return MSDC_SUCCESS;
        } else if ((fgMode == 1) && ((MSDC_READ32(MSDC_INT) & vector) == vector)) {
            _u4MsdcAccuVect |= MSDC_READ32(MSDC_INT);
            MSDC_WRITE32(MSDC_INT, _u4MsdcAccuVect & vector);
            return MSDC_SUCCESS;
        }

        if ((MSDC_READ32(MSDC_INT) & retVector) != 0) {
        	MSDC_LOG(MSG_LVL_ERR, "unexpected interrupt: INT=0x%x\n", MSDC_READ32(MSDC_INT));
            // return directly
            return MSDC_FAILED;
        }

        HAL_Delay_us(1);
    }

	if (i == timeoutCnt)
		MSDC_LOG(MSG_LVL_ERR, "expected INT=0x%x, real INT=0x%x\n", vector, MSDC_READ32(MSDC_INT));

    // Timeout case
    return MSDC_FAILED;
}

VOID MsdcHandleResp(msdc_cmd *pCmd, UINT32 *pu4respType, UINT32 *pu4sdcCmd)
{
    // Handle the response
    switch (*pu4respType) {
    case RESPONSE_NO:
        MSDC_LOG(MSG_LVL_INFO, "CMD%d CMD 0x%08X ARG 0x%08X WITHOUT RESPONSE\n", pCmd->cmd_idx, *pu4sdcCmd, pCmd->cmd_arg);

    case RESPONSE_R1:
	//case RESPONSE_R5:
    //case RESPONSE_R6:
    //case RESPONSE_R7:
    case RESPONSE_R1B:
        pCmd->resp[0] = MSDC_READ32(SDC_RESP0);
		MSDC_LOG(MSG_LVL_INFO, "CMD%d CMD 0x%08X ARG 0x%08X RESPONSE_R1/R5/R6/R7/R1B:%08X\n", pCmd->cmd_idx, *pu4sdcCmd, pCmd->cmd_arg,
			                                                                                  pCmd->resp[0]);
		break;

    case RESPONSE_R2:
        pCmd->resp[0] = MSDC_READ32(SDC_RESP0);
        pCmd->resp[1] = MSDC_READ32(SDC_RESP1);
        pCmd->resp[2] = MSDC_READ32(SDC_RESP2);
        pCmd->resp[3] = MSDC_READ32(SDC_RESP3);
        MSDC_LOG(MSG_LVL_INFO, "CMD%d CMD 0x%08X ARG 0x%08X RESPONSE_R2:%08X %08X %08X %08X\n", pCmd->cmd_idx, *pu4sdcCmd, pCmd->cmd_arg,
			                                                                                    pCmd->resp[0], pCmd->resp[1], pCmd->resp[2], pCmd->resp[3]);
        break;

    case RESPONSE_R3:
	//case RESPONSE_R4:
        pCmd->resp[0] = MSDC_READ32(SDC_RESP0);
        MSDC_LOG(MSG_LVL_INFO, "CMD%d CMD 0x%08X ARG 0x%08X RESPONSE_R3:%08X\n", pCmd->cmd_idx, *pu4sdcCmd, pCmd->cmd_arg,
			                                                                     pCmd->resp[0]);
        break;
	//case RESPONSE_R4:
    //    pCmd->resp[0] = MSDC_READ32(SDC_RESP0);
    //   MSDC_LOG(MSG_LVL_INFO, "CMD%d CMD 0x%08X ARG 0x%08X RESPONSE_R4:%08X\n", pCmd->cmd_idx, *pu4sdcCmd, pCmd->cmd_arg,			                                                                     pCmd->resp[0]);
     //   break;

	default:
		MSDC_LOG(MSG_LVL_ERR, "ERROR! %s, invalid param at line %d \n",__FUNCTION__, __LINE__);
		break;
    }

    if (pCmd->pBuff) {
        MSDC_LOG(MSG_LVL_TRACE, "Data flags:0x%x Buffer Addr:%08X Len:%08X!!\n", pCmd->flags,
                                                                              (UINT32)(pCmd->pBuff),
                                                                              (UINT32)(pCmd->blocks * pCmd->block_size));
    }

	if ((*pu4respType) == RESPONSE_R1B) {
		INT32 retry = 30000; /* 30 seconds */
		while ((MSDC_READ32(MSDC_PS) & MSDC_PS_DAT0) != MSDC_PS_DAT0) {
			retry--;
			if (retry == 0) {
				MSDC_LOG(MSG_LVL_ERR, "ERROR! R1B CMD %d arg 0x%x wait EMMC BUSY timeout! \n",pCmd->cmd_idx,pCmd->cmd_arg);
				MsdcDumpRegister();
				break;
			}
			HAL_Delay_us(1);
		}
	}
}

static int MsdcDatErrChk(msdc_cmd *pCmd, int intr_val, int tmo)
{
	int i4Ret  = MSDC_SUCCESS;
	if(intr_val & INT_SD_DATTO)
    {
    	if (!g_msdc_pub_info.g_msdc_runing_autok)
        MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - Data Timeout (AccuVect 0x%08X INTR 0x%08X).\n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT));
        i4Ret = CMD_ERR_WAIT_DATATO;
        goto CHK_END;
    }
    else if(intr_val & INT_SD_DATA_CRCERR)
    {
    	if (!g_msdc_pub_info.g_msdc_runing_autok)
        MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - Data CRC Error (AccuVect 0x%08X INTR 0x%08X).\n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT));
        i4Ret = CMD_ERR_DATA_CRCERR;
        goto CHK_END;
    }
	else if (intr_val & (INT_SD_AUTOCMD_TO | INT_SD_AUTOCMD_RESP_CRCERR))
	{
		if (!g_msdc_pub_info.g_msdc_runing_autok)
		MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - AutoCmd  Error (AccuVect 0x%08X INTR 0x%08X)@line %d \n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT),__LINE__);
		i4Ret = CMD_ERR_AUTO12_CMD_ERR;
		goto CHK_END;
	}

	if (tmo)
	{
		i4Ret = CMD_ERR_WAIT_DATATO;
	}


CHK_END:
	return i4Ret;

}

static int MsdcCmdErrChk(msdc_cmd *pCmd, int intr_val, int tmo)
{
	int i4Ret  = MSDC_SUCCESS;
	if (intr_val & INT_SD_CMDTO)
    {
		if (!g_msdc_pub_info.g_msdc_runing_autok)
        MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - CMD Timeout (AccuVect 0x%08X INTR 0x%08X).@%sline %d \n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT), __FUNCTION__, __LINE__);
        i4Ret = CMD_ERR_WAIT_CMD_TO;
        goto CHK_END;
    }
	else if (intr_val & INT_SD_RESP_CRCERR)
    {
		if (!g_msdc_pub_info.g_msdc_runing_autok)
	        MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - CMD CRC Error (AccuVect 0x%08X INTR 0x%08X).@%sline %d\n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT),__FUNCTION__,__LINE__);
	        i4Ret = CMD_ERR_RESP_CRCERR;
	        goto CHK_END;
    }
	else if (intr_val & (INT_SD_AUTOCMD_TO | INT_SD_AUTOCMD_RESP_CRCERR))
	{
		if (!g_msdc_pub_info.g_msdc_runing_autok)
	        MSDC_LOG(MSG_LVL_ERR, "CMD%d ARG 0x%08X - AUTO CMD  Error (AccuVect 0x%08X INTR 0x%08X).@%sline %d\n", pCmd->cmd_idx, pCmd->cmd_arg, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT),__FUNCTION__,__LINE__);
	        i4Ret = CMD_ERR_AUTO23_CMD_ERR;
	        goto CHK_END;
    }

	if (tmo)
	{
		i4Ret = CMD_ERR_WAIT_CMD_TO;
	}

CHK_END:
	return i4Ret;

}
VOID MsdcSetupCmd(msdc_cmd *pCmd, UINT32 *pu4respType,UINT32 *pu4sdcCmd)
{

	UINT32 u4BufLen = (0 == pCmd->blocks)?  (pCmd->partial_blk_len) : (UINT32)(pCmd->blocks * pCmd->block_size);
	UINT32 u4CurBlkNum = (0 == pCmd->blocks)? 1 : pCmd->blocks;
    /* Figure out the response type */
    switch (pCmd->cmd_idx) {
    case CMD0_GO_IDLE_STATE:
        *pu4respType = RESPONSE_NO;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_NO;
        break;

    case CMD1_MMC_SEND_OP_COND:
        *pu4respType = RESPONSE_R3;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R3;
        break;

    case CMD2_ALL_SEND_CID:
        *pu4respType = RESPONSE_R2;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R2;
        break;

    case CMD3_SEND_RELATIVE_ADDR:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

	case CMD5_IO_SEND_OP_COND:
		*pu4respType = RESPONSE_R4;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R4;
        break;

    case CMD6_MMC_SWITCH:
        if (HOST_EMMC == pCmd->host_type) {
            *pu4respType = RESPONSE_R1B;
            (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1B;
        } else {
            *pu4respType = RESPONSE_R1;
            (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
            if (pCmd->flags & CMD_WITH_DATA) {
                (*pu4sdcCmd) |= (DTYPE_SINGLE_BLK | SDC_CMD_READ);
                MSDC_WRITE32(SDC_BLK_NUM, 1);
            }
        }
        break;

    case CMD7_SELECT_CARD:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

    case CMD8_SEND_IF_COND:
        if (HOST_EMMC == pCmd->host_type) {
            *pu4respType = RESPONSE_R1;
            (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_READ);
            MSDC_WRITE32(SDC_BLK_NUM, 1);
        } else {
        	MSDC_LOG(MSG_LVL_ERR, "\nWarning! it's in SD CMD8 \n");
            *pu4respType = RESPONSE_R7;
            (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R7;
        }
        break;

    case CMD9_SEND_CSD:
        *pu4respType = RESPONSE_R2;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R2;
        break;

	case CMD11_VOLTAGE_SWITCH:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | SDC_CMD_VOL_SWITCH);
        break;

    case CMD12_STOP_TRANSMISSION:
        *pu4respType = RESPONSE_R1B;
        (*pu4sdcCmd) |= (SDC_CMD_STOP | SDC_CMD_RSPTYPE_R1B);
        break;

    case CMD13_SEND_STATUS:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        if (pCmd->flags & CMD_WITH_DATA) {
            (*pu4sdcCmd) |= (DTYPE_SINGLE_BLK | SDC_CMD_READ);
            MSDC_WRITE32(SDC_BLK_NUM, 1);
        }
        break;

    case CMD17_READ_SINGLE_BLOCK:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_READ);
        MSDC_WRITE32(SDC_BLK_NUM, 1);
        break;

    case CMD18_READ_MULTIPLE_BLOCK:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_MULTI_BLK | SDC_CMD_READ);
        MSDC_WRITE32(SDC_BLK_NUM, u4CurBlkNum);
        break;

	case CMD19_SEND_TUNING_PATTERN:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_AUTO_CMD19);
        break;

	case CMD21_SEND_TUNING_BLOCK:
		*pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_READ);
        MSDC_WRITE32(SDC_BLK_NUM, 1);

    case CMD23_SET_BLOCK_COUNT:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

    case CMD24_WRITE_BLOCK:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_WRITE);
        MSDC_WRITE32(SDC_BLK_NUM, 1);
        break;

    case CMD25_WRITE_MULTIPLE_BLOCK:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_MULTI_BLK | SDC_CMD_WRITE);
        MSDC_WRITE32(SDC_BLK_NUM, u4CurBlkNum);
        break;

    case CMD27_PROGRAM_CSD:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_WRITE);
        MSDC_WRITE32(SDC_BLK_NUM, 1);
        break;

    case CMD28_SET_WRITE_PROT:
    case CMD29_CLR_WRITE_PROT:
        *pu4respType = RESPONSE_R1B;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1B;
        break;

    case CMD30_SEND_WRITE_PROT:
    case CMD31_SEND_WRITE_PROT_TYPE:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

    case CMD35_ERASE_WR_BLK_START:
    case CMD36_ERASE_WR_BLK_END:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

    case CMD38_ERASE:
        *pu4respType = RESPONSE_R1B;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1B;
        break;

    case ACMD41_SD_SEND_OP_COND:
        *pu4respType = RESPONSE_R3;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R3;
        break;

    case ACMD51_SEND_SCR:
        *pu4respType = (RESPONSE_R1);
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R1 | DTYPE_SINGLE_BLK | SDC_CMD_READ);
        MSDC_WRITE32(SDC_BLK_NUM, 1);
        break;

	case CMD52_IO_RW_DIRECT:
        *pu4respType = (RESPONSE_R5);
        (*pu4sdcCmd) |= (SDC_CMD_RSPTYPE_R5);
        break;

	case CMD53_IO_RW_EXTENDED:
        *pu4respType = (RESPONSE_R5);
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R5;
		if (pCmd->cmd_arg & 0x80000000)
            (*pu4sdcCmd) |= SDC_CMD_WRITE;
		else
		    (*pu4sdcCmd) |= SDC_CMD_READ;

		if (u4CurBlkNum > 1)
            (*pu4sdcCmd) |= DTYPE_MULTI_BLK;
		else
            (*pu4sdcCmd) |= DTYPE_SINGLE_BLK;
		MSDC_WRITE32(SDC_BLK_NUM, u4CurBlkNum);
        break;

    case CMD55_APP_CMD:
        *pu4respType = RESPONSE_R1;
        (*pu4sdcCmd) |= SDC_CMD_RSPTYPE_R1;
        break;

    }

	// auto-cmd19 handle
	if (pCmd->cmd_idx == CMD19_SEND_TUNING_PATTERN)
	    MSDC_LOG(MSG_LVL_ERR, "cmd19 tuning setup successful!\n");

    // Set Blk Length & auto-cmd12/23
    if (pCmd->flags & CMD_WITH_DATA) {
        // special for sdio device
        if (pCmd->cmd_idx == CMD53_IO_RW_EXTENDED) {
            (*pu4sdcCmd) |= (pCmd->block_size << SDC_CMD_LEN_SHIFT);
        } else {
	        (*pu4sdcCmd) |= (MIN_NUM((u4BufLen), SDHC_BLK_SIZE) << SDC_CMD_LEN_SHIFT);
	        if (u4CurBlkNum > 1) {
                if (pCmd->flags & AUTO_CMD_23_MASK)
					(*pu4sdcCmd) |= (SDC_CMD_AUTO_CMD23);
				else if (pCmd->flags & AUTO_CMD_12_MASK)
					(*pu4sdcCmd) |= (SDC_CMD_AUTO_CMD12);
	        }
        }
    }

    // Set SDC_CMD.CMD
    (*pu4sdcCmd) |= (pCmd->cmd_idx & 0x3F);

    // Set SDC Argument
    MSDC_WRITE32(SDC_ARG, pCmd->cmd_arg);

    // Send the commands to the device
    MSDC_WRITE32(SDC_CMD, (*pu4sdcCmd));

    MSDC_LOG(MSG_LVL_INFO, "MsdcSendCmd : CMD%d ARGU%08X : CMD%08X ARGU%08X BLK_NUM%08X !!\n", pCmd->cmd_idx, pCmd->cmd_arg,
                                                                          MSDC_READ32(SDC_CMD),
                                                                          MSDC_READ32(SDC_ARG),
                                                                          MSDC_READ32(SDC_BLK_NUM));
}

/*
 * public function
 */
INT32 MsdcReqCmdStart(msdc_cmd *pCmd)
{
    UINT32 u4CmdDoneVect,respType = RESPONSE_NO, sdcCmd = 0;
    INT32 i4Ret = CMD_ERR_SUCCESS;
    UINT32 u4CmdTimeout = 10 * MSDC_WAIT_CMD_TIMEOUT_LIMIT_COUNT;
    // Check if rx/tx fifo is zero
    MsdcChkFifo();

    // Clear interrupt Vector
    MsdcClrIntr();

    if (pCmd->cmd_idx != CMD12_STOP_TRANSMISSION) {
        if (MsdcWaitHostIdle(MSDC_WAIT_SDC_BUS_TIMEOUT_LIMIT_COUNT)) {
            i4Ret = ERR_CMD_FAILED;
            MSDC_LOG(MSG_LVL_ERR, "Wait HOST idle failed: SDC_STS(%08X), MSDC_INT(%08X)!\n", MSDC_READ32(SDC_STS), MSDC_READ32(MSDC_INT));
			MSDC_LOG(MSG_LVL_ERR, "CMD%d ARGU%08X : flags 0x%x ,blocks 0x%x, blk size 0x%x !!\n", pCmd->cmd_idx, pCmd->cmd_arg,
																	   pCmd->flags,pCmd->blocks,pCmd->block_size);
			MSDC_LOG(MSG_LVL_ERR, "partial len 0x%x \n",pCmd->partial_blk_len);
			MsdcDumpRegister();
            goto ErrorEnd;
        }
    }

    MsdcSetupCmd(pCmd, &respType, &sdcCmd);

    // Wait for command and response if existed
    if (pCmd->cmd_idx == CMD19_SEND_TUNING_PATTERN)
        u4CmdDoneVect = INT_AUTOCMD19_DONE;
	else
    {
    	/*Mark INT_SD_CMDTO | INT_SD_RESP_CRCERR, we must get CMD_RDY for cmd send.*/
        u4CmdDoneVect = INT_SD_CMDRDY;
    }

	if((pCmd->flags & CMD_WITH_DATA) &&
	   ((pCmd->blocks * pCmd->block_size) > SDHC_BLK_SIZE) &&
       (pCmd->flags & AUTO_CMD_23_MASK))
    {
        u4CmdDoneVect |= INT_SD_AUTOCMD_RDY;
    }

	/*it seems the emmc problem, cmd12 will can not get interrupt in 12ms, it's over SPEC,now enlarge wait time for cmd12*/
	if (CMD12_STOP_TRANSMISSION == pCmd->cmd_idx)

		u4CmdTimeout = 60 * MSDC_WAIT_CMD_TIMEOUT_LIMIT_COUNT;

    if (MSDC_SUCCESS != MsdcWaitIntr(u4CmdDoneVect, u4CmdTimeout, 1))
    {
        MSDC_LOG(MSG_LVL_ERR, "Failed to send CMD/RESP, DoneVect = 0x%08x INTR = 0x%08x. cmd idx%d, arg 0x%x \n", u4CmdDoneVect, MSDC_READ32(MSDC_INT),
				pCmd->cmd_idx,pCmd->cmd_arg);

		i4Ret = MsdcCmdErrChk(pCmd, MSDC_READ32(MSDC_INT), 1);

		MSDC_WRITE32(MSDC_INT, MSDC_READ32(MSDC_INT) & u4CmdDoneVect);

        goto ErrorEnd;
    }

    i4Ret = MsdcCmdErrChk(pCmd, _u4MsdcAccuVect, 0);
	if (i4Ret)
		goto ErrorEnd;


	if(pCmd->cmd_idx == CMD19_SEND_TUNING_PATTERN)
	{
        MSDC_LOG(MSG_LVL_ERR, "tuning result: %08x\n", MSDC_READ32(ACMD19_STS));
		i4Ret =  MSDC_SUCCESS;
		goto ErrorEnd;
	}

	// Handle the response
    MsdcHandleResp(pCmd, &respType, &sdcCmd);

ErrorEnd:

	if (!g_msdc_pub_info.g_msdc_runing_autok)
	{
		MSDC_LOG(MSG_LVL_INFO, "=>CMD %d DONE!ret %d accu 0x%x, INT 0x%x ,resp 0x%x \n",pCmd->cmd_idx,i4Ret,_u4MsdcAccuVect,MSDC_READ32(MSDC_INT),pCmd->resp[0]);
	}

    return i4Ret;
}

INT32 MsdcHandleDataTransfer(msdc_cmd *pCmd)
{
    UINT32 dataEndIntr = 0, u4CmdDoneVect = 0;
	INT32 i4Ret = CMD_ERR_SUCCESS;

    /*
	 * auto-cmd13 interrupt will raise after response come in
     * but auto-cmd12 interrupt will raise after all data is transferred.
     * we don't handle auto-cmd13 at the response stage, so we can
     * handle auto-cmd12/13 together here.
     */
    if (((pCmd->blocks * pCmd->block_size) > SDHC_BLK_SIZE) &&
       (pCmd->flags & AUTO_CMD_12_MASK))
    {
        dataEndIntr = INT_SD_AUTOCMD_RDY;
    }

    if (DATA_MODE_PIO & pCmd->flags)
    {
        UINT32 u4RxFifoCnt, u4TxFifoCnt;
        UINT32 *pBufData = (UINT32 *)(pCmd->pBuff);
        UINT32 u4BufLen = (0 == pCmd->blocks)?  (pCmd->partial_blk_len) : (UINT32)(pCmd->blocks * pCmd->block_size);
        UINT32 u4BufEnd = (UINT32)pBufData + u4BufLen;
        UINT32 u4RxCnt = 0;

        if (pBufData == NULL) {
    		MSDC_LOG(MSG_LVL_ERR, "Error! pBufData is NULL @line %d \n",__LINE__);
			return CMD_ERR_FAILED;
    	}

		if (0 == u4BufLen) {
    		MSDC_LOG(MSG_LVL_ERR, "Error! u4BufLen is 0  @line %d \n",__LINE__);
			return CMD_ERR_FAILED;
    	}

        u4CmdDoneVect = INT_SD_DATTO | INT_SD_DATA_CRCERR;

        // Read
        if (pCmd->flags & CMD_READ_OPERATION) {
            while (u4BufLen) {

			         if (u4CmdDoneVect & MSDC_READ32(MSDC_INT)) {
						MSDC_LOG(MSG_LVL_ERR, "Error! PIO read error,MSDC_INT 0x%x  @line %d \n",MSDC_READ32(MSDC_INT),__LINE__);
						break;
                     }
                // wait until fifo has enough data
                u4RxFifoCnt = (MSDC_READ32(MSDC_FIFOCS) & MSDC_FIFOCS_RXFIFOCNT_MASK);

                while ((u4BufEnd > (UINT32)pBufData) && (sizeof(INT32) <= u4RxFifoCnt)) {
                    // Read Data
                    *pBufData = MSDC_READ32(MSDC_RXDATA);
                     pBufData++;
                     u4RxFifoCnt -= sizeof(INT32);
                     u4BufLen -= sizeof(INT32);
                     u4RxCnt += sizeof(INT32);


                }
            } // end while (u4BufLen)
        } else {
            while (u4BufEnd > (UINT32)pBufData) {
				// Check if error done vector occurs
                if (u4CmdDoneVect & MSDC_READ32(MSDC_INT)) {
                    MSDC_LOG(MSG_LVL_ERR, "DoneVect:0x%08X, INTR:0x%08X\n", u4CmdDoneVect, MSDC_READ32(MSDC_INT));
                    break;
                }

                // wait until fifo has enough space
                while(1) {
                    if((MSDC_READ32(MSDC_FIFOCS) & MSDC_FIFOCS_TXFIFOCNT_MASK) == 0)
                        break;
                }

                u4TxFifoCnt = MSDC_FIFO_LEN;

                if (sizeof(INT32) <= u4TxFifoCnt) {
                    while ((u4BufEnd > (UINT32)pBufData) && (sizeof(INT32) <= u4TxFifoCnt))
                    {
                        // Write Data
                        MSDC_WRITE32(MSDC_TXDATA, *pBufData);
                        pBufData++;
                        u4TxFifoCnt -= sizeof(INT32);
                    }
                }
            } // end while
        } // end if (pCmd->flags & CMD_READ_OPERATION)

        // Wait for data complete
        if (MSDC_SUCCESS != MsdcWaitIntr((dataEndIntr | INT_SD_XFER_COMPLETE), 10*MSDC_WAIT_DATA_COMPLETE_TIMEOUT_LIMIT_COUNT, 1)) {
            MSDC_LOG(MSG_LVL_ERR, "PIO Wait Intr timeout (AccuVect 0x%08X INTR 0x%08X).\n", _u4MsdcAccuVect, MSDC_READ32(MSDC_INT));

			i4Ret =  MsdcDatErrChk(pCmd, MSDC_READ32(MSDC_INT), 1);

			//Clear the error interupts
			//MSDC_WRITE32(MSDC_INT, MSDC_READ32(MSDC_INT) & u4CmdDoneVect);
			MsdcClrIntr();
            goto ErrorEnd;
        }

		i4Ret =  MsdcDatErrChk(pCmd, _u4MsdcAccuVect, 0);
		if (i4Ret)
			goto ErrorEnd;

        if((_u4MsdcAccuVect & ~(dataEndIntr | INT_SD_XFER_COMPLETE)) || (0 != MSDC_READ32(MSDC_INT)))
        {
            MSDC_LOG(MSG_LVL_ERR, "UnExpect status (AccuVect 0x%08X INTR 0x%08X).\n", _u4MsdcAccuVect, MSDC_READ32(MSDC_INT));
            i4Ret = CMD_ERR_DATA_FAILED;
            goto ErrorEnd;
        }
    } else if (DATA_MODE_BASIC_DMA & pCmd->flags) {
        UINT32 *pBufData = (UINT32 *)(pCmd->pBuff);
        UINT32 u4BufLen = (0 == pCmd->blocks)?  (pCmd->partial_blk_len) : (UINT32)(pCmd->blocks * pCmd->block_size);

		if (pBufData == NULL) {
    		MSDC_LOG(MSG_LVL_ERR, "Error! pBufData is NULL @line %d \n",__LINE__);
			return CMD_ERR_FAILED;
    	}

		if (0 == u4BufLen) {
    		MSDC_LOG(MSG_LVL_ERR, "Error! u4BufLen is 0  @line %d \n",__LINE__);
			return CMD_ERR_FAILED;
    	}

		MSDC_WRITE32(DMA_SA, (UINT32)pBufData);
		MSDC_WRITE32(DMA_LENGTH, u4BufLen);
		MSDC_WRITE32(DMA_CTRL, (DMA_BST_64 << DMA_CTRL_BST_SHIFT) | DMA_CTRL_LAST_BUF | DMA_CTRL_START);

		if (MSDC_SUCCESS != MsdcWaitIntr(dataEndIntr | INT_SD_XFER_COMPLETE | INT_DMA_XFER_DONE, 10*MSDC_WAIT_DATA_COMPLETE_TIMEOUT_LIMIT_COUNT, 1)) {
			if (!g_msdc_pub_info.g_msdc_runing_autok)
				MSDC_LOG(MSG_LVL_ERR, "BasicDMA %s: Failed to send/receive data (AccuVect 0x%08X INTR 0x%08X). %s line %d\r\n", __FUNCTION__, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT), __FILE__, __LINE__);

			i4Ret =  MsdcDatErrChk(pCmd, MSDC_READ32(MSDC_INT), 1);

			//Clear the error interupts
			//MSDC_WRITE32(MSDC_INT, MSDC_READ32(MSDC_INT) & u4CmdDoneVect);
			MsdcClrIntr();

			goto ErrorEnd;
		}

		i4Ret =  MsdcDatErrChk(pCmd, _u4MsdcAccuVect, 0);
		if (i4Ret)
			goto ErrorEnd;

		if((_u4MsdcAccuVect & ~(dataEndIntr | INT_SD_XFER_COMPLETE | INT_DMA_XFER_DONE)) || (0 != MSDC_READ32(MSDC_INT)))
		{
			MSDC_LOG(MSG_LVL_ERR, "%s: Unexpected status (AccuVect 0x%08X INTR 0x%08X). %s line %d\r\n", __FUNCTION__, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT), __FILE__, __LINE__);
			return CMD_ERR_DATA_FAILED;
		}

    } else if (DATA_MODE_DESC_DMA & pCmd->flags) {
        MSDC_SETBIT(DMA_CTRL, DMA_CTRL_START);
        // Wait for sd xfer complete
        if (MSDC_SUCCESS != MsdcWaitIntr((dataEndIntr | INT_SD_XFER_COMPLETE | INT_DMA_XFER_DONE | INT_DMA_Q_EMPTY), 10*MSDC_WAIT_DATA_COMPLETE_TIMEOUT_LIMIT_COUNT, 1)) {
            MSDC_LOG(MSG_LVL_ERR, "DescDMA %s: Failed to send/receive data (AccuVect 0x%08X INTR 0x%08X). %s line %d\r\n", __FUNCTION__, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT), __FILE__, __LINE__);

			i4Ret =  MsdcDatErrChk(pCmd, MSDC_READ32(MSDC_INT), 1);

			//Clear the error interupts
			//MSDC_WRITE32(MSDC_INT, MSDC_READ32(MSDC_INT) & u4CmdDoneVect);
			MsdcClrIntr();
			return i4Ret;
        }

        if ((_u4MsdcAccuVect & ~(dataEndIntr | INT_SD_XFER_COMPLETE | INT_DMA_XFER_DONE | INT_DMA_Q_EMPTY)) || (0 != MSDC_READ32(MSDC_INT))) {
            MSDC_LOG(MSG_LVL_ERR, "%s: Unexpected status (AccuVect 0x%08X INTR 0x%08X). %s line %d\r\n", __FUNCTION__, _u4MsdcAccuVect, MSDC_READ32(MSDC_INT), __FILE__, __LINE__);
            i4Ret = CMD_ERR_WAIT_DATATO;
            goto ErrorEnd;
        }

        if (MSDC_READ32(DMA_CFG) & (DMA_CFG_GPD_CS_ERR)) {
            MSDC_LOG(MSG_LVL_ERR, "Descriptor DMA GPD checksum error");
            i4Ret = CMD_ERR_DATA_FAILED;
            goto ErrorEnd;
        }

        if (MSDC_READ32(DMA_CFG) & (DMA_CFG_BD_CS_ERR)) {
            MSDC_LOG(MSG_LVL_ERR, "Descriptor DMA BD checksum error");
            i4Ret = CMD_ERR_DATA_FAILED;
            goto ErrorEnd;
        }

        // Check DMA status
        if (0 != (MSDC_READ32(DMA_CFG) & (DMA_CFG_DMA_STATUS))) {
            MSDC_LOG(MSG_LVL_ERR, "%s: Incorrect DMA status. DMA_CFG: 0x%08X\r\n", __FUNCTION__, MSDC_READ32(DMA_CFG));
            i4Ret = CMD_ERR_DATA_FAILED;
            goto ErrorEnd;
        }
    }

ErrorEnd:
	/* DMA must be stopped even if the transfer was succeed */
	MsdcStopDMA();
    return i4Ret;
}

INT32 MsdcRequest(msdc_cmd *pCmd)
{
    INT32 i4Ret = MSDC_SUCCESS;
    i4Ret = MsdcReqCmdStart(pCmd);
    if (MSDC_SUCCESS != i4Ret) {
        if (pCmd->pBuff) {
			/*for both cmd error or dat error, we should use error hanlde to wait card change back to stable state*/
			MSDC_LOG(MSG_LVL_ERR, "cmd %d error, goto error handle\n",pCmd->cmd_idx);
            if (MSDC_SUCCESS != MsdcErrorHandling(pCmd))
				goto ErrorEnd;
        }

		#if MSDC_NEW_FIFO_PATH
		if (g_msdc_pub_info.g_msdc_runing_autok) {
			//No error handle before autok
			goto ErrorEnd;
		} else {
			if ((CMD_ERR_WAIT_CMD_TO == i4Ret) && (CMD12_STOP_TRANSMISSION == pCmd->cmd_idx))
			{
				//cmd12 timeout not run tuning
				goto ErrorEnd;
			}
			else
			{
				i4Ret = MsdcOnlineAutoKTune(TRUE, FALSE, FALSE,pCmd);
				if (MSDC_SUCCESS != i4Ret)
					goto ErrorEnd;
			}		}
		#else
		i4Ret = MsdcReqCmdTune(pCmd);
		if (MSDC_SUCCESS != i4Ret)
			goto ErrorEnd;
		#endif
    }

    if (pCmd->pBuff) {
        i4Ret = MsdcHandleDataTransfer(pCmd);
        if (MSDC_SUCCESS != i4Ret) {
            if (MSDC_SUCCESS != MsdcErrorHandling(pCmd))
                goto ErrorEnd;
        }
    }

ErrorEnd:
    return i4Ret;
}

#endif
