/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*-----------------------------------------------------------------------------
  *
  * $Author: victor.zhuo $
  * $Date: 2016/07/02 $
  * $RCSfile: pmic_drvif.h,v $
  * $Revision: #1 $
  *
  *---------------------------------------------------------------------------*/

/*************************************************************************
 *
 * Filename:
 * ---------
 *   $Workfile: pmic_drvif.h $
 *
 * Project:
 * --------
 *   MT5886
 *
 * Description:
 * ------------
 * PMIC header file
 *
 * Author:
 * -------
 *
 *
 * Last changed:
 * -------------
 * $Author: victor.zhuo $
 *
 * $Modtime: 16/07/02 8:25p $
 *
 * $Revision: #1 $
*************************************************************************/

#ifndef _PMIC_DRVIF_H_
#define _PMIC_DRVIF_H_


#if defined(CC_PMIC_MARCO_POLO)

#include "general.h"

#define PMIC_CH (4)
#define PMIC_CLKDIV   (0x100)
#define PMIC_DEVADDR_MARCO (0x90)
#define PMIC_DEVADDR_POLO (0x92)


typedef enum {
    E_PMIC_FUNC_STB3V6,
    E_PMIC_FUNC_3V3SB,
    E_PMIC_FUNC_AVDD1V0_STB_1,
    E_PMIC_FUNC_AVDD1V0_STB_2,
    E_PMIC_FUNC_VCCK,
    E_PMIC_FUNC_DDRV,
    E_PMIC_FUNC_AVDD1V2,
    E_PMIC_FUNC_VCC3IO_EMMC,
    E_PMIC_FUNC_AVDD3V3,
    E_PMIC_FUNC_AVDD33_HDMI,
    E_PMIC_FUNC_TUNER_3V3,
    E_PMIC_FUNC_AVDD33_ETH_STB,
    E_PMIC_FUNC_VCC3IO_SD,
    E_PMIC_FUNC_MHL_VBUS,
    E_PMIC_FUNC_USB1_VBUS,
    E_PMIC_FUNC_USB2_VBUS,
    E_PMIC_FUNC_USB4_VBUS,
    E_PMIC_FUNC_CI_VCC,
    E_PMIC_FUNC_MAX,
}E_PMIC_FUNCTION;

typedef enum {
    E_PMIC_DEFAULT_ON,
    E_PMIC_DISABLE,
    E_PMIC_PLUS_3_PCT,
    E_PMIC_PLUS_5_PCT,
    E_PMIC_PLUS_10_PCT,
    E_PMIC_MINUS_3_PCT,
    E_PMIC_MINUS_5_PCT,
    E_PMIC_MINUS_10_PCT,
}E_PMIC_VOLTAGE;


typedef struct {
    UINT8  u1PMICDevAddr;
    UCHAR  ucName[16];
    UINT8  u1RegAddr;
    UINT8  u1RegValCurrent;
    UINT8  u1RegValOff;
    UINT8  u1RegValP3;
    UINT8  u1RegValM3;
    UINT8  u1RegValP5;
    UINT8  u1RegValM5;
    UINT8  u1RegValP10;
    UINT8  u1RegValM10;
}PMIC_FUNC_INFO_T;

UINT16 u1PMICFuncOnOff(E_PMIC_FUNCTION eFunc, UINT8 u1OnOff);
UINT16 u1PMICFuncSetV(E_PMIC_FUNCTION eFunc, E_PMIC_VOLTAGE eVoltage);
#ifdef CC_MTK_LOADER
void PMIC_Setup(void);
#endif

#endif

#endif
